/**
   The preOrder() method returns a pre-order
   traversal of the nodes of a BTree.

   The inOrder() method returns an in-order
   traversal of the nodes of a BTree.

   The postOrder() method returns a post-order
   traversal of the nodes of a BTree.
*/

public class Traverse
{
   public static String preOrder(BTree tree)
   {
      String result = "";

      // Process the root node.
      result += tree.element + " ";

      // Recursively traverse the left sub tree.
      if ( null != tree.left )
      {
         result += preOrder( tree.left );
      }

      // Recursively traverse the right sub tree.
      if ( null != tree.right )
      {
         result += preOrder( tree.right );
      }

      return result;
   }


   public static String inOrder(BTree tree)
   {
      String result = "";

      // Recursively traverse the left sub tree.
      if ( null != tree.left )
      {
         result += inOrder( tree.left );
      }

      // Process the root node.
      result += tree.element + " ";

      // Recursively traverse the right sub tree.
      if ( null != tree.right )
      {
         result += inOrder( tree.right );
      }

      return result;
   }


   public static String postOrder(BTree tree)
   {
      String result = "";

      // Recursively traverse the left sub tree.
      if ( null != tree.left )
      {
         result += postOrder( tree.left );
      }

      // Recursively traverse the right sub tree.
      if ( null != tree.right )
      {
         result += postOrder( tree.right );
      }

      // Process the root node.
      result += tree.element + " ";

      return result;
   }
}
