/**
   A program that build three more BTree data structures.
*/
public class Example_BTree_3
{
   public static void main(String[] args)
   {
      BTree<Integer> btree3 = new BTree<>(3,
                                          new BTree<>(4,
                                                      new BTree<>(6),
                                                      new BTree<>(7)),
                                          new BTree<>(5));
      testBtree(btree3, 3);

      BTree<Integer> btree4 = new BTree<>(101,
                                          new BTree<>(104,
                                                      new BTree<>(106),
                                                      new BTree<>(107)),
                                          new BTree<>(105,
                                                      null, // empty tree
                                                      new BTree<>(109)));
      testBtree(btree4, 4);

      BTree<Integer> btree5 = new BTree<>(1001, btree3, btree4);
      testBtree(btree5, 5);
   }

   public static <T> void testBtree(BTree<T> btree, int number)
   {
      System.out.println("\n==== Binary Tree number " + number);
      System.out.println( BTree.toString(btree) );
      BTree2dot.btree2dot(btree, "example" + number);
      BTree2png.btree2png("example" + number);

      System.out.println("degree = " + BTree.degree(btree));
      System.out.println("height =  " + BTree.height(btree));
      System.out.println("size = " + BTree.size(btree));
      System.out.println("isFull = " + BTree.isFull(btree));

      System.out.println( BTree.preOrder(btree) );
      System.out.println( BTree.inOrder(btree) );
      System.out.println( BTree.postOrder(btree) );
   }
}
