/**
   This concrete subclass of BTree defines a binary tree node.
   This is one case of the two cases in the algebraic data type
   for a binary tree.
*/
public class BTreeNode<T> extends BTree<T>
{
   private T element;
   private BTree<T> left;
   private BTree<T> right;

   /**
      Construct a leaf node.
   */
   public BTreeNode(T element)
   {
      this(element, new EmptyBTree<T>(), new EmptyBTree<T>());
   }


   /**
      Construct a BTree with the given binary trees
      as its left and right branches.
   */
   public BTreeNode(T element, BTree<T> left, BTree<T> right)
   {
      this.element = element;
      this.left = left;
      this.right = right;
   }


   @Override
   public T root()
   {
      return element;
   }

   @Override
   public BTree<T> left()
   {
      return left;
   }

   @Override
   public BTree<T> right()
   {
      return right;
   }

   @Override
   public boolean isEmpty()
   {
      return false;
   }
}//BTreeNode
