/**
   A program that build three more BTree data structures.
*/
public class Example_BTree_3
{
   public static void main(String[] args)
   {
      BTree<Integer> btree3 = new BTreeNode<>(3,
                                          new BTreeNode<>(4,
                                                      new BTreeNode<>(6),
                                                      new BTreeNode<>(7)),
                                          new BTreeNode<>(5));
      testBtree(btree3, 3);

      BTree<Integer> btree4 = new BTreeNode<>(101,
                                          new BTreeNode<>(104,
                                                      new BTreeNode<>(106),
                                                      new BTreeNode<>(107)),
                                          new BTreeNode<>(105,
                                                      new EmptyBTree<>(),
                                                      new BTreeNode<>(109)));
      testBtree(btree4, 4);

      BTree<Integer> btree5 = new BTreeNode<>(1001, btree3, btree4);
      testBtree(btree5, 5);
   }

   public static <T> void testBtree(BTree<T> btree, int number)
   {
      System.out.println("\n==== Binary Tree number " + number);
      System.out.println( btree );
      BTree2dot.btree2dot(btree, "example" + number);
      BTree2png.btree2png("example" + number);

      System.out.println("degree = " + btree.degree());
      System.out.println("height =  " + btree.height());
      System.out.println("size = " + btree.size());
      System.out.println("isFull = " + btree.isFull());

      System.out.println( btree.preOrder() );
      System.out.println( btree.inOrder() );
      System.out.println( btree.postOrder() );
   }
}
