class BTreeG<T>
{
   public T element;
   public BTreeG<T> left;
   public BTreeG<T> right;

   public BTreeG(T element)
   {
      this.element = element;
      this.left  = null;
      this.right = null;
   }

   public BTreeG(T element, BTreeG<T> left, BTreeG<T> right)
   {
      this.element = element;
      this.left  = left;
      this.right = right;
   }

   @Override public String toString() {
      String result = "";
      if (null == left && null == right)
         result += element;
      else {
         result += "(" + element;
         if (null != left)
            result += " " + left.toString(); // recursion
         else
            result += " ()";
         if (null != right)
            result += " " + right.toString(); // recursion
         else
            result += " ()";
         result += ")";
      }
      return result;
   }
}


public class BTreeGeneric
{
   public static void main(String[] args)
   {
      BTreeG<String> btree1 =
         new BTreeG<>("a",
                     new BTreeG<>("b",
                                 new BTreeG<>("d"),
                                 new BTreeG<>("e")),
                     new BTreeG<>("c",
                                 null,
                                 new BTreeG<>("f",
                                             new BTreeG<>("g",
                                                         null,
                                                         new BTreeG<>("h")),
                                             null)));

      BTreeG<Integer> btree2 =
         new BTreeG<>(1,
                     new BTreeG<>(2,
                                 new BTreeG<>(3),
                                 new BTreeG<>(4)),
                     new BTreeG<>(5,
                                 null,
                                 new BTreeG<>(6,
                                     new BTreeG<>(7,
                                                 null,
                                                 new BTreeG<>(8)),
                                     null)));

      System.out.println( btree1 );
      System.out.println( btree2 );
   }
}
